#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_PNM_Image.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Wizard.H>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <FL/Fl_Text_Display.H>
#include <iostream>


int convert2(int i, int j, int n, int k)
{
int a;
a = (i*n + j)*3 + k;
return a;
}

int my_mod(int a, int b)
{
	if (a>=0)
		return a%b;
	else
		return (a+b)%b;

}

void perspective(char *input_name, float M, float k0, float shift_parameter, char *output_name, int *array)
{

	/*GETTING m AND n*/
	FILE *input; input = fopen(input_name,"r");
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);
	/*PPM FORMAT GIVES FIRST THA WIDTH*/
	int n; fscanf(input,"%d",&n);
	int m; fscanf(input,"%d",&m);
	fscanf(input,"%3s",word);
	
	
	float shift; shift = n/2 - shift_parameter;
	int i2,j2,k2;
	

	/*SHIFTING TO CREATE THE CENTER IMAGE*/
	int *previous_array;
	previous_array = (int*)malloc(m*n*3*sizeof(int)); int z2;
	int *new_array;
	new_array = (int*)malloc(m*n*3*sizeof(int));
	for (z2=0;z2<3*m*n;++z2)
		previous_array[z2]=array[z2];
	for (i2=0;i2<m;++i2){
		for (j2=0;j2<n;++j2){
			for (k2=0;k2<3;++k2){
				int c; c=j2-shift;
				int d; d=my_mod(c,n);
				new_array[convert2(i2,j2,n,k2)] = previous_array[convert2(i2,d,n,k2)];}
		}
	}

/*CREATING THE ARRAY THAT WILL BECOME THE RESULT IMAGE*/
	int m2; m2=n/k0;
	int n2; n2=n/k0;
	int *ima;
	ima = (int*)malloc(m2*n2*3*sizeof(int)); int i; int j; int k;
	double theta; double phi;
	for (i=0;i<m2;++i){
		for (j=0;j<n2;++j){
			for (k=0;k<3;++k){
			theta = atan(2*i*M/n2 - M);
			phi = atan(((-2*M*j/n2) + M)*cos(theta));
			int u; int v; double pi;
			pi = 3.1416;
			u = ceil(((phi/(pi/2))+1)*k0*(n2/4));
			v = fmod(ceil(((theta/pi)+1)*k0*(n2/2)),k0*n2)+1;
			ima[convert2(n2-1-j,i,n2,k)] = new_array[convert2(u,v,n,k)];
			}
		}
	}
	free(previous_array);
	free(new_array);

/*int z;
for (z=0;z<n2*n2*3;++z)
printf("%d ",ima[z]);*/


/*CREATING A PGM FILE FROM ARRAY IMA*/


	FILE *output;
	output = fopen(output_name,"w");
	fprintf(output,"P3\n");
	fprintf(output,"# CREATOR: The GIMP's PNM Filter Version 1.0\n");
	fprintf(output,"%d %d\n", n2, n2);
	fprintf(output,"255\n");
	int y;
	for (y=0;y<n2*n2*3;++y)
		fprintf(output,"%d\n", ima[y]);

	free(ima);

}



int *image_to_matrix(char *input_name2)
{
	/*INPUTS*/
	FILE *input; input = fopen(input_name2,"r");
//	float M; M = atof(argv[2]); /*region of the projection plane*/
//	int k0; k0=atof(argv[3]); /*scaling of the image*/

	/*GETTING m AND n*/
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);
	/*PPM FORMAT GIVES FIRST THA WIDTH*/
	int n; fscanf(input,"%d",&n);
	int m; fscanf(input,"%d",&m);
	fscanf(input,"%3s",word);


	/*GETTING THE ORIGINAL IMAGE*/
	int *array;
	array = (int*)malloc(m*n*3*sizeof(int));
	int w; int i2; int j2; int k2;
	for (i2=0;i2<m;++i2){
		for (j2=0;j2<n;++j2){
			for (k2=0;k2<3;++k2){
			fscanf(input,"%d",&w);
			array[convert2(i2,j2,n,k2)] = w;
			}
		}
	}
	return array;
}



void write_occlusion_file(char *left_name, char *right_name)
{
	FILE *output;
	output = fopen("kz2_master_camera.txt","w");
	
	fprintf(output,"LOAD_COLOR match-v3.3.src/images/%s match-v3.3.src/images/%s \n", left_name, right_name);
	fprintf(output,"SET disp_range -50 0 0 0         # x_min y_min x_max y_max \n \n");
	fprintf(output,"SET iter_max 30 \n");
	fprintf(output,"SET randomize_every_iteration \n \n");
	fprintf(output,"# Regularization parameter. AUTO computes only an approximate \n");
	fprintf(output,"# value. Should be tuned to get the best result. \n");
	fprintf(output,"# If results look too noisy try increasing lambda \n");
	fprintf(output,"# If results look oversmoothed try decreasing lambda \n");
	fprintf(output,"# If there are too many occluded pixels try increasing K \n");
	fprintf(output,"SET lambda AUTO  \n \n");
	fprintf(output,"############################################################# \n");
	fprintf(output,"# Other parameters that can be changed: \n");
	fprintf(output,"############################################################# \n");
	fprintf(output,"#SET data_cost ?    # L1 or L2 (default is L2) \n");
	fprintf(output,"#SET I_threshold2 ? # intensity threshold - switches between \n");
	fprintf(output,"                    # lambda1 and lambda2 (default is 8) \n");
	fprintf(output,"#SET lambda1 ?      # (default is 3*lambda) \n");
	fprintf(output,"#SET lambda2 ?      # (default is lambda) \n");
	fprintf(output,"#SET K ?            # (default is 5*lambda) \n");
	fprintf(output,"############################################################# \n \n");
	fprintf(output,"# Running the algorithm \n");
	fprintf(output,"KZ2 \n \n");
	fprintf(output,"# Saving results with occlusions \n");
	fprintf(output,"SAVE_X kz2_occ_master_camera.pgm \n");
	fprintf(output,"SAVE_X_SCALED kz2_occ_master_camera.ppm \n \n");
	fprintf(output,"# Filling occlusions \n");
	fprintf(output,"FILL_OCCLUSIONS \n \n");
	fprintf(output,"# Saving results \n");
	fprintf(output,"SAVE_X kz2_master_camera.pgm \n");
	fprintf(output,"SAVE_X_SCALED kz2_master_camera.ppm \n");
	
	
/*# Regularization parameter. AUTO computes only an approximate
# value. Should be tuned to get the best result.
# If results look too noisy try increasing lambda
# If results look oversmoothed try decreasing lambda
# If there are too many occluded pixels try increasing K
SET lambda AUTO 

#############################################################
# Other parameters that can be changed:
#############################################################
#SET data_cost ?    # L1 or L2 (default is L2)
#SET I_threshold2 ? # intensity threshold - switches between
                    # lambda1 and lambda2 (default is 8)
#SET lambda1 ?      # (default is 3*lambda)
#SET lambda2 ?      # (default is lambda)
#SET K ?            # (default is 5*lambda)
#############################################################

# Running the algorithm
KZ2

# Saving results with occlusions
SAVE_X kz2_occ.pgm
SAVE_X_SCALED kz2_occ.ppm

# Filling occlusions
FILL_OCCLUSIONS

# Saving results
SAVE_X kz2.pgm
SAVE_X_SCALED kz2.ppm*/
}





class perspective_parameters{
public:
	char argument[100];
	char input_name[100];
	float M;
	float k0;
	float shift_parameter;
	char output_name[100];
	int *matrix;
public:
	perspective_parameters(char* input_name2); //constructor
	perspective_parameters(); //empty constructor
	void print(); 
};

perspective_parameters::perspective_parameters(char *input_name2)
{
	sprintf(argument, "%s", input_name2);
	sprintf(input_name, "%s.ppm", input_name2);
	M = 1;
	k0 = 8;
	shift_parameter = 1000;
	sprintf(output_name, "%s_result.ppm", input_name2);
	matrix = image_to_matrix(input_name);
}

perspective_parameters::perspective_parameters()
{
	sprintf(argument, "empty");
	sprintf(input_name, "empty");
	M = 1;
	k0 = 8;
	shift_parameter = 1000;
	sprintf(output_name, "empty");
	matrix = NULL;
}

void perspective_parameters::print()
{
	printf("argument = %s \n", argument);
	printf("input_name = %s \n", input_name);
	printf("M = %.2f \n", M);
	printf("k0 = %.2f \n", k0);
	printf("shift_parameter = %.2f \n", shift_parameter);
	printf("output_name = %s \n", output_name);
}

/*perspective_parameters parameters1("2000_2-DSC_0001_DSC_0008");*/


	





class Box : public Fl_Box{

public:

Fl_Box *pixbuf;
perspective_parameters *parameters1;

int handle(int e)
{
	switch(e){
		case FL_PUSH:
			parameters1->shift_parameter = 4*this->posx();
			perspective(parameters1->input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, parameters1->output_name,parameters1->matrix);
			printf("field of view of %.2f degrees \n", (180/3.1415)*2*atan(parameters1->M));
			Fl_PNM_Image *buf = new Fl_PNM_Image(parameters1->output_name);
			pixbuf->image(buf);
			pixbuf->redraw();
			break;
			return e;
	}
    return e;
}

public:
	int posx(){return Fl::event_x() - this->x();}
	int posy(){return Fl::event_y() - this->y();}
	void set_buf(Fl_Box *boxx){pixbuf = boxx;}
        Box(int X, int Y, int W, int H, perspective_parameters *params):Fl_Box(X,Y,W,H)
        {
		parameters1 = params;
        }
};


Fl_PNM_Image *buf_image1;


class Master_Camera_Box : public Fl_Box{

public:

Fl_Box *pixbuf;
perspective_parameters *parameters1;


int handle(int e)
{
	char right_input_name[100]; char right_output_name[100]; int *right_matrix;
	
	switch(e){
		case FL_PUSH:
			sprintf(right_input_name, "%s_right.ppm", parameters1->argument);
			sprintf(right_output_name, "%s_right_result.ppm", parameters1->argument);
			right_matrix = image_to_matrix(right_input_name);
			printf("%s \n", right_output_name);
			perspective(right_input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, right_output_name,right_matrix);
			if ( buf_image1 != NULL )
				delete buf_image1;
			buf_image1 = new Fl_PNM_Image(right_output_name);
			this->image( buf_image1 );
			this->redraw();
			
			break;
			return e;
	}
    return e;
}

        Master_Camera_Box(int X, int Y, int W, int H, perspective_parameters *params):Fl_Box(X,Y,W,H)
        {
		parameters1 = params;
        }
        
        Master_Camera_Box():Fl_Box(0,0,0,0){}
};







class Zoom_In_Button : public Fl_Button{

public:

Fl_Box *pixbuf;
perspective_parameters *parameters1;

int handle(int e)
{
	switch(e){
		case FL_PUSH:
			this->deactivate();
			Fl::check();
			parameters1->M = parameters1->M*0.8;
			perspective(parameters1->input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, parameters1->output_name,parameters1->matrix);
			printf("field of view of %.2f degrees \n", (180/3.1415)*2*atan(parameters1->M));
			Fl_PNM_Image *buf = new Fl_PNM_Image(parameters1->output_name);
			pixbuf->image(buf);
			pixbuf->redraw();
			this->activate();
			 
			break;
			return e;
		}
	return e;
}

void set_buf(Fl_Box *boxx){pixbuf = boxx;}
Zoom_In_Button(int X, int Y, int W, int H, const char *label, perspective_parameters *params):Fl_Button(X,Y,W,H,label){
		parameters1 = params;
        }
};





class Zoom_Out_Button : public Fl_Button{

public:

Fl_Box *pixbuf;
perspective_parameters *parameters1;

int handle(int e)
{
	switch(e){
		case FL_PUSH:
			this->deactivate();
			Fl::check();
			parameters1->M = parameters1->M*(1/0.8);
			perspective(parameters1->input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, parameters1->output_name,parameters1->matrix);
			printf("field of view of %.2f degrees \n", (180/3.1415)*2*atan(parameters1->M));
			Fl_PNM_Image *buf = new Fl_PNM_Image(parameters1->output_name);
			pixbuf->image(buf);
			pixbuf->redraw();
			this->activate();
			break;
			return e;
		}
	return e;
}

void set_buf(Fl_Box *boxx){pixbuf = boxx;}
Zoom_Out_Button(int X, int Y, int W, int H, const char *label, perspective_parameters *params):Fl_Button(X,Y,W,H,label){
		parameters1 = params;
        }
};





class Perspective_Button : public Fl_Button{

public:

perspective_parameters *parameters1;

int handle(int e)
{
	switch(e){
		case FL_PUSH:
		this->deactivate();
		Fl::check();
		
		char objects_input_name[100]; char objects_output_name[100];
		sprintf(objects_input_name, "objects_%s", parameters1->input_name);
		sprintf(objects_output_name, "objects_%s", parameters1->output_name);
		int *objects_matrix =  image_to_matrix(objects_input_name);
		perspective(objects_input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, objects_output_name,objects_matrix);
		
		char big_output_name[100];
		sprintf(big_output_name, "big_%s", parameters1->output_name);
		perspective(parameters1->input_name, parameters1->M, (parameters1->k0)/2, parameters1->shift_parameter, big_output_name,parameters1->matrix);
		
		char big_objects_output_name[100];
		sprintf(big_objects_output_name, "big_%s", objects_output_name);
		perspective(objects_input_name, parameters1->M, (parameters1->k0)/2, parameters1->shift_parameter, big_objects_output_name,objects_matrix);
		
		
		this->activate();
		label("Perspective processed!");
			break;
			return e;
		}
	return e;
}

Perspective_Button(int X, int Y, int W, int H, const char *label, perspective_parameters *params):Fl_Button(X,Y,W,H,label){
		parameters1 = params;
        }
};





class Master_Button : public Fl_Button{

public:

perspective_parameters *parameters1;

int handle(int e)
{
	switch(e){
		case FL_PUSH:
		label("Processing,\nplease wait");
		this->deactivate();
		Fl::check();
		char right_input_name[100]; char right_output_name[100];
		sprintf(right_input_name, "%s_right.ppm", parameters1->argument);
		sprintf(right_output_name, "%s_right_result.ppm", parameters1->argument);
		int *right_matrix =  image_to_matrix(right_input_name);
		perspective(right_input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, right_output_name,right_matrix);
		
		perspective(parameters1->input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, "master_camera.ppm",parameters1->matrix);
		
		perspective(parameters1->input_name, parameters1->M, (parameters1->k0)/2, parameters1->shift_parameter, "big_master_camera.ppm",parameters1->matrix);
		
		
		
		char objects_input_name[100];
		sprintf(objects_input_name, "objects_%s", parameters1->input_name);
		int *objects_matrix =  image_to_matrix(objects_input_name);
		perspective(objects_input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, "master_camera_objects.ppm",objects_matrix);
		
		perspective(objects_input_name, parameters1->M, (parameters1->k0)/2, parameters1->shift_parameter, "big_master_camera_objects.ppm",objects_matrix);
		
		write_occlusion_file(parameters1->output_name, right_output_name);
		
		FILE *output;
		output = fopen("master_camera.txt","w");
		fprintf(output,"%s\n", parameters1->argument);
		fclose(output);
		
		exit(0);
			break;
			return e;
		}
	return e;
}

Master_Button(int X, int Y, int W, int H, const char *label, perspective_parameters *params):Fl_Button(X,Y,W,H,label){
		parameters1 = params;
        }
};



/*class Camera_Button : public Fl_Button{

public:

perspective_parameters *parameters1;
char *right_input_name;
char *right_output_name;

int handle(int e)
{
	switch(e){
		case FL_PUSH:
		label("This is the master camera...");
		/*char right_input_name[100];
		sprintf(right_input_name, "%s.ppm", right_input_name2);
		sprintf(right_output_name, "%s.ppm", right_output_name2);*/
		
		/*int *right_matrix =  image_to_matrix(right_input_name);
		perspective(right_input_name, parameters1->M, parameters1->k0, parameters1->shift_parameter, right_output_name,right_matrix);
			break;
			return e;
		}
	return e;
}

Camera_Button(int X, int Y, int W, int H, const char *label, perspective_parameters *params, char *right_input_name2, char *right_output_name2):Fl_Button(X,Y,W,H,label){
		parameters1 = params;
		right_input_name = right_input_name2;
		right_output_name = right_output_name2;
        }
        
Camera_Button():Fl_Button(0,0,0,0){}
};*/




class perspective_selector{
public:
	perspective_parameters parameters1;
	
	Box *mybox;
	Fl_Box *mybox2;
	Zoom_In_Button *but1;
	Zoom_Out_Button *but2;
	Perspective_Button *but3;
	Master_Button *but4;
	Fl_PNM_Image *pixbuf;
	Fl_PNM_Image *pixbuf2;
	
	float x0,y0;
	
	perspective_selector(char* input_name2, char *input_name2_little_file, float y0_2); //constructor
	perspective_selector(); //empty constructor
	
};

perspective_selector::perspective_selector():parameters1()
{
	//&parameters1;
	
	x0 = y0 = 0;
	mybox = NULL;
	mybox2 = NULL;
	but1 = NULL;
	but2 = NULL;
	but3 = NULL;
	but4 = NULL;
	pixbuf = NULL;
	pixbuf2 = NULL;
}

perspective_selector::perspective_selector(char *input_name2, char *input_name2_little_file, float y0_2) : parameters1(input_name2)
{
	x0 = 30;
	y0 = y0_2;
	
	mybox = new Box(x0,y0, 500,250,&parameters1);
	mybox2 = new Fl_Box(500+2*x0, y0, 250, 250);
	but1 = new Zoom_In_Button(500+2*x0,250+y0,125,25,"Zoom in",&parameters1);
	but2 = new Zoom_Out_Button(500+2*x0+125,250+y0,125,25,"Zoom out",&parameters1);
	but3 = new Perspective_Button(50+x0,250+y0,400,25,"Click here to process the current perspective",&parameters1);
	but4 = new Master_Button(750+2*x0+x0,90+y0,125,70,"Set this as \n the Master \n Camera",&parameters1);
	
	
	
	pixbuf = new Fl_PNM_Image(input_name2_little_file);
	perspective(parameters1.input_name, parameters1.M, parameters1.k0, parameters1.shift_parameter, parameters1.output_name,parameters1.matrix);
	printf("field of view of %.2f degrees \n", (180/3.1415)*2*atan(parameters1.M));
	pixbuf2 = new Fl_PNM_Image(parameters1.output_name);
	mybox->image(pixbuf);
	mybox2->image(pixbuf2);
	
	mybox->set_buf(mybox2);
	but1->set_buf(mybox2);
	but2->set_buf(mybox2);
	
}



/*perspective_selector selector1;*/

/*Box *mybox = (Box*)0;
Fl_Box *mybox2 = (Box*)0;*/

Master_Camera_Box *box_image1;

/*perspective_parameters selector1_parameters;*/
//Camera_Button camera1;

/*Fl_Wizard *G_wiz = 0;

void back_cb(Fl_Widget*,void*) { G_wiz->prev(); }
void next_cb(Fl_Widget*,void*) {  
	G_wiz->next();
	
	if ( buf_image1 != NULL )
		delete buf_image1;
	buf_image1 = new Fl_PNM_Image(selector1.parameters1.output_name);
	
	//box_image1 = new Master_Camera_Box(30, 250, 250, 250, &selector1.parameters1);
	
	box_image1->image(buf_image1);
	box_image1->redraw();
	//Camera_Button camera1(30,300, 125, 25, "Camera 1", &selector1_parameters, "1000_camera1_right.ppm", "1000_camera1_right_result.ppm");
	}
void done_cb(Fl_Widget*,void*) { exit(0); }*/





void MyClose(Fl_Widget* w, void* userdata)
{
	exit(1);
	return;
}

int main(int argc, char *argv[])
{
	Fl::scheme("gtk+");
	char name1[100]; char name2[100];
	char name3[100]; char name4[100];
	char name5[100]; char name6[100];
	
	char name7[100]; char name8[100];
	char name9[100]; char name10[100];
	char name11[100]; char name12[100];
	
	//perspective_selector selector1;
	
	 
	
	
	
	
	/*Fl_Button *but_close;*/
	
	
	Fl_Window *win = new Fl_Window(0,0,1000,1000, "Window 1 - Choose a perspective for each camera");
	/*but_close = new Fl_Button(30,950,200,25,"Go to next window");
	but_close->callback(MyClose);*/
	
	/*G_wiz = new Fl_Wizard(0,0,1000,1000);*/
	
	
	//Wizard Page 1
	//{
	
	/*Fl_Group *g = new Fl_Group(0,0,1000,1000);
	Fl_Button *next = new Fl_Button(30,950,100,25,"Next"); next->callback(next_cb);*/
	
	if (argc==2){	
	sprintf(name1,"1000_%s",argv[1]); sprintf(name2,"250_%s.ppm",argv[1]);
	perspective_selector selector1(name1, name2, 30);
	}
	
	if (argc==3){	
	sprintf(name1,"1000_%s",argv[1]); sprintf(name2,"250_%s.ppm",argv[1]);
	perspective_selector selector1(name1, name2, 30);
	
	sprintf(name3,"1000_%s",argv[2]); sprintf(name4,"250_%s.ppm",argv[2]);
	perspective_selector selector2(name3, name4, 330);
	}
	
	if (argc==4){	
	sprintf(name1,"1000_%s",argv[1]); sprintf(name2,"250_%s.ppm",argv[1]);
	perspective_selector selector1(name1, name2, 30);
	
	sprintf(name3,"1000_%s",argv[2]); sprintf(name4,"250_%s.ppm",argv[2]);
	perspective_selector selector2(name3, name4, 330);
	
	sprintf(name5,"1000_%s",argv[3]); sprintf(name6,"250_%s.ppm",argv[3]);
	perspective_selector selector3(name5, name6, 630);
	}
	
	if (argc>4)
	printf("\n Too many input images! It has to be at most 3! \n \n");
	
	/*Fl_Text_Buffer *buff = new Fl_Text_Buffer();
	Fl_Text_Display *disp = new Fl_Text_Display(30, 950, 800, 25);
	disp->buffer(buff);
	win->resizable(*disp);
	win->show();
	buff->text("After propcessed all the perspectives above, please chosse the master camera");*/
	
	/*g->end();
	
	}*/
	
	
	//Wizard Page 2
	//{
	
	/*Fl_Box *box1;
	Fl_PNM_Image *buf1;*/
	/*Fl_Group *g = new Fl_Group(0,0,1000,1000);
	Fl_Button *back = new Fl_Button(30,950,100,25,"Back"); back->callback(back_cb);*/
	/*Fl_Box *box1;
	Fl_PNM_Image *buf1;*/
	/*Camera_Button *camera1;*/
	
	/*char right_input1[100]; char right_output1[100];
	char right_input2[100]; char right_output2[100];
	char right_input3[100]; char right_output3[100];*/
	
	//Camera_Button camera1;
	
	
	/*if (argc==2){
	sprintf(right_input1,"1000_%s_right.ppm",argv[1]); sprintf(right_output1,"1000_%s_right_result.ppm",argv[1]);
	box_image1 = new Master_Camera_Box(30, 250, 250, 250, &selector1.parameters1);
	buf_image1 = new Fl_PNM_Image(selector1.parameters1.output_name);
	box_image1->image(buf_image1);*/
	
	
	//ALGO PODE NÃO ESTAR DECLARADO! (VER CONSTRUTOR VAZIO DE PERSPECTIVE_PARAMETERS!
	
	
	
	//box1->redraw();
	//camera1->show();
	
	/*Camera_Button camera1(30,300, 125, 25, "Camera 1", &selector1_parameters, right_input1, right_output1);*/
	
	/*}
	
	g->end();
	

	}
	
	G_wiz->end();*/
	
	
	win->end();
	
	win->show();
	
	return(Fl::run());
	


}
