#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_PNM_Image.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Wizard.H>
#include <FL/Fl_Multiline_Output.H>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <FL/Fl_Text_Display.H>
#include <iostream>


int convert2(int i, int j, int n, int k)
{
int a;
a = (i*n + j)*3 + k;
return a;
}

int my_mod(int a, int b)
{
	if (a>=0)
		return a%b;
	else
		return (a+b)%b;

}

int *image_to_matrix(char *input_name2)
{
	/*INPUTS*/
	FILE *input; input = fopen(input_name2,"r");
//	float M; M = atof(argv[2]); /*region of the projection plane*/
//	int k0; k0=atof(argv[3]); /*scaling of the image*/

	/*GETTING m AND n*/
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);
	/*PPM FORMAT GIVES FIRST THA WIDTH*/
	int n; fscanf(input,"%d",&n);
	int m; fscanf(input,"%d",&m);
	fscanf(input,"%3s",word);


	/*GETTING THE ORIGINAL IMAGE*/
	int *array;
	array = (int*)malloc(m*n*3*sizeof(int));
	int w; int i2; int j2; int k2;
	for (i2=0;i2<m;++i2){
		for (j2=0;j2<n;++j2){
			for (k2=0;k2<3;++k2){
			fscanf(input,"%d",&w);
			array[convert2(i2,j2,n,k2)] = w;
			}
		}
	}
	return array;
}

void combine_images(int *image_matrix, int *objects_matrix, char *combined_name, int m, int n)
{
	FILE *output;
	output = fopen(combined_name,"w");
	fprintf(output,"P3\n");
	fprintf(output,"# CREATOR: The GIMP's PNM Filter Version 1.0\n");
	fprintf(output,"%d %d\n", n, m);
	fprintf(output,"255\n");
	int y; int x;
	for (y=0;y<m*n*3;++y){
		x = 0.7*image_matrix[y]+0.3*objects_matrix[y];
		fprintf(output,"%d\n", x);
	}
	//fclose(output);

}


char *text_display(char* input_text)
{

	char *text;
	text = (char*)malloc(1024*sizeof(char));
	char *text1, *text2, *text3, *text4, *text5, *text6, *text7, *text8, *text9;
	text1 = (char*)malloc(1024*sizeof(char));
	text2 = (char*)malloc(1024*sizeof(char));
	text3 = (char*)malloc(1024*sizeof(char));
	text4 = (char*)malloc(1024*sizeof(char));
	text5 = (char*)malloc(1024*sizeof(char));
	text6 = (char*)malloc(1024*sizeof(char));
	text7 = (char*)malloc(1024*sizeof(char));
	text8 = (char*)malloc(1024*sizeof(char));
	text9 = (char*)malloc(1024*sizeof(char));
	
	FILE *input; input = fopen(input_text,"r");
	int a11, a12, a13, a21, a22, a23, a31, a32, a33;
	
	fscanf(input,"%d",&a11); fscanf(input,"%d",&a12); fscanf(input,"%d",&a13);
	fscanf(input,"%d",&a21); fscanf(input,"%d",&a22); fscanf(input,"%d",&a23);
	fscanf(input,"%d",&a31); fscanf(input,"%d",&a32); fscanf(input,"%d",&a33);
	
	if (a11==1)
		sprintf(text1,"Red object from Camera 1");
	
	if (a12==1)
		sprintf(text2,"Red object from Camera 2");
	
	if (a13==1)
		sprintf(text3,"Red object from Camera 3");
		
	if (a21==1)
		sprintf(text4,"Green object from Camera 1");
		
	if (a22==1)
		sprintf(text5,"Green object from Camera 2");
		
	if (a23==1)
		sprintf(text6,"Green object from Camera 3");
		
	if (a31==1)
		sprintf(text7,"Blue object from Camera 1");
		
	if (a32==1)
		sprintf(text8,"Blue object from Camera 2");
		
	if (a33==1)
		sprintf(text9,"Blue object from Camera 3");
	
	sprintf(text, "\n %s \n %s \n %s \n %s \n %s \n %s \n %s \n %s \n %s", text1, text2, text3, text4, text5, text6, text7, text8, text9);
	free(text1); free(text2); free(text3); free(text4); free(text5); free(text6); free(text7); free(text8); free(text9); 
	
	return text;

}


class Refresh_Button : public Fl_Button{

public:

Fl_Text_Buffer *refresh_buff;

int handle(int e)
{
	switch(e){
		case FL_PUSH:
			this->deactivate();
			Fl::check();
			char *current_text;
			current_text = text_display("objects_from_cameras.txt");
			refresh_buff->text(current_text);
			break;
			return e;
		case FL_RELEASE:
			this->activate();
			break;
			return e;
		}
	return e;
}

void set_buf(Fl_Text_Buffer *buffer){refresh_buff = buffer;}
Refresh_Button(int X, int Y, int W, int H, const char *label):Fl_Button(X,Y,W,H,label){}

};


class Object_Camera_Button : public Fl_Button{

public:

int index_1; int index_2;

int handle(int e)
{
	FILE *input; 
	int a11, a12, a13, a21, a22, a23, a31, a32, a33;
	FILE *output;
	/*input = fopen("objects_from_cameras.txt","r");
	fscanf(input,"%d",&a11); fscanf(input,"%d",&a12); fscanf(input,"%d",&a13);
	fscanf(input,"%d",&a21); fscanf(input,"%d",&a22); fscanf(input,"%d",&a23);
	fscanf(input,"%d",&a31); fscanf(input,"%d",&a32); fscanf(input,"%d",&a33);
	output = fopen("objects_from_cameras.txt","r+");*/
	
	switch(e){
		case FL_PUSH:
			this->deactivate();
			Fl::check();
			input = fopen("objects_from_cameras.txt","r");
			fscanf(input,"%d",&a11); fscanf(input,"%d",&a12); fscanf(input,"%d",&a13);
			fscanf(input,"%d",&a21); fscanf(input,"%d",&a22); fscanf(input,"%d",&a23);
			fscanf(input,"%d",&a31); fscanf(input,"%d",&a32); fscanf(input,"%d",&a33);
			fclose(input);
			output = fopen("objects_from_cameras.txt","r+");
			
			if (index_1 == 1 && index_2 == 1){
				a11 = 1; a12 = 0; a13 = 0;
			}
			
			if (index_1 == 1 && index_2 == 2){
				a11 = 0; a12 = 1; a13 = 0;
			}
			
			if (index_1 == 1 && index_2 == 3){
				a11 = 0; a12 = 0; a13 = 1;
			}
			
			if (index_1 == 2 && index_2 == 1){
				a21 = 1; a22 = 0; a23 = 0;
			}
			
			if (index_1 == 2 && index_2 == 2){
				a21 = 0; a22 = 1; a23 = 0;
			}
			
			if (index_1 == 2 && index_2 == 3){
				a21 = 0; a22 = 0; a23 = 1;
			}
			
			if (index_1 == 3 && index_2 == 1){
				a31 = 1; a32 = 0; a33 = 0;
			}
			
			if (index_1 == 3 && index_2 == 2){
				a31 = 0; a32 = 1; a33 = 0;
			}
			
			if (index_1 == 3 && index_2 == 3){
				a31 = 0; a32 = 0; a33 = 1;
			}

			fprintf(output, "%d %d %d %d %d %d %d %d %d", a11, a12, a13, a21, a22, a23, a31, a32, a33);
			fclose(output);
			
			break;
			return e;
		case FL_RELEASE:
			this->activate();
			break;
			return e;
		}
	return e;
}

Object_Camera_Button(int X, int Y, int W, int H, const char *label, int ind_1, int ind_2):Fl_Button(X,Y,W,H,label)
	{
		index_1 = ind_1;
		index_2 = ind_2;
	}

};



void done_cb(Fl_Widget*,void*) { exit(0); }

int main(int argc, char *argv[])
{
	Fl::scheme("gtk+");
	char image1[100]; char objects1[100]; char combined1[100];
	char image2[100]; char objects2[100]; char combined2[100];
	char image3[100]; char objects3[100]; char combined3[100];
	
	int *image1_matrix; int *objects1_matrix;
	int *image2_matrix; int *objects2_matrix;
	int *image3_matrix; int *objects3_matrix;
	
	char *camera_text = "Yeah";
	//Fl_Multiline_Output *output1 = new Fl_Multiline_Output(30,0,100,25);
	
	FILE *output;
	output = fopen("objects_from_cameras.txt","w");
	fprintf(output, "0 0 0 0 0 0 0 0 0");
	fclose(output);
	
	Fl_Window *win = new Fl_Window(0,0,870,680, "Window 3 - Set a camera for each object");
	
	
	
	Fl_Text_Buffer *buff = new Fl_Text_Buffer();
	Fl_Text_Display *disp = new Fl_Text_Display(30, 500, 250, 150, "Objects");
	disp->buffer(buff);
	char *text_example;
	text_example = text_display("objects_from_cameras.txt");
	buff->text(text_example);
	
	Refresh_Button *refresh;
	refresh = new Refresh_Button(280,540,100,25, "Refresh");
	refresh->set_buf(buff);
		
	if (argc==2){	
		sprintf(image1,"1000_%s_result.ppm",argv[1]); sprintf(objects1,"objects_1000_%s_result.ppm",argv[1]); sprintf(combined1,"combined_1000_%s_result.ppm",argv[1]);
		image1_matrix = image_to_matrix(image1); objects1_matrix = image_to_matrix(objects1);
		combine_images(image1_matrix, objects1_matrix, combined1, 250, 250);
		
		Fl_Multiline_Output *text1 = new Fl_Multiline_Output(115,30,80,20);
		camera_text = "Camera 1";
		text1->value(camera_text);
		
		Fl_Box *image_box1 = new Fl_Box(30,50,250,250);
		Fl_PNM_Image *image1 = new Fl_PNM_Image(combined1);
		image_box1->image(image1);
		image_box1->redraw();
		
		Object_Camera_Button *red_camera1;
		red_camera1 = new Object_Camera_Button(30,310,250,25,"Red object from Camera 1", 1, 1);
		Object_Camera_Button *green_camera1;
		green_camera1 = new Object_Camera_Button(30,335,250,25,"Green object from Camera 1", 2, 1);
		Object_Camera_Button *blue_camera1;
		blue_camera1 = new Object_Camera_Button(30,360,250,25,"Blue object from Camera 1", 3, 1);
	}
	
	if (argc==3){	
		sprintf(image1,"1000_%s_result.ppm",argv[1]); sprintf(objects1,"objects_1000_%s_result.ppm",argv[1]); sprintf(combined1,"combined_1000_%s_result.ppm",argv[1]);
		image1_matrix = image_to_matrix(image1); objects1_matrix = image_to_matrix(objects1);
		combine_images(image1_matrix, objects1_matrix, combined1, 250, 250);
		
		Fl_Multiline_Output *text1 = new Fl_Multiline_Output(115,30,80,20);
		camera_text = "Camera 1";
		text1->value(camera_text);
		
		Fl_Box *image_box1 = new Fl_Box(30,50,250,250);
		Fl_PNM_Image *image1 = new Fl_PNM_Image(combined1);
		image_box1->image(image1);
		image_box1->redraw();
		
		Object_Camera_Button *red_camera1;
		red_camera1 = new Object_Camera_Button(30,310,250,25,"Red object from Camera 1", 1, 1);
		Object_Camera_Button *green_camera1;
		green_camera1 = new Object_Camera_Button(30,335,250,25,"Green object from Camera 1", 2, 1);
		Object_Camera_Button *blue_camera1;
		blue_camera1 = new Object_Camera_Button(30,360,250,25,"Blue object from Camera 1", 3, 1);
		
		
		
		sprintf(image2,"1000_%s_result.ppm",argv[2]); sprintf(objects2,"objects_1000_%s_result.ppm",argv[2]); sprintf(combined2,"combined_1000_%s_result.ppm",argv[2]);
		image2_matrix = image_to_matrix(image2); objects2_matrix = image_to_matrix(objects2);
		combine_images(image2_matrix, objects2_matrix, combined2, 250, 250);
		
		Fl_Multiline_Output *text2 = new Fl_Multiline_Output(115+30+250,30,80,20);
		camera_text = "Camera 2";
		text2->value(camera_text);
		
		Fl_Box *image_box2 = new Fl_Box(30+250+30,50,250,250);
		Fl_PNM_Image *image2 = new Fl_PNM_Image(combined2);
		image_box2->image(image2);
		image_box2->redraw();
		
		Object_Camera_Button *red_camera2;
		red_camera2 = new Object_Camera_Button(310,310,250,25,"Red object from Camera 2", 1, 2);
		Object_Camera_Button *green_camera2;
		green_camera2 = new Object_Camera_Button(310,335,250,25,"Green object from Camera 2", 2, 2);
		Object_Camera_Button *blue_camera2;
		blue_camera2 = new Object_Camera_Button(310,360,250,25,"Blue object from Camera 2", 3, 2);
	}
	
	if (argc==4){	
		sprintf(image1,"1000_%s_result.ppm",argv[1]); sprintf(objects1,"objects_1000_%s_result.ppm",argv[1]); sprintf(combined1,"combined_1000_%s_result.ppm",argv[1]);
		image1_matrix = image_to_matrix(image1); objects1_matrix = image_to_matrix(objects1);
		combine_images(image1_matrix, objects1_matrix, combined1, 250, 250);
		
		Fl_Multiline_Output *text1 = new Fl_Multiline_Output(115,30,80,20);
		camera_text = "Camera 1";
		text1->value(camera_text);
		
		Fl_Box *image_box1 = new Fl_Box(30,50,250,250);
		Fl_PNM_Image *image1 = new Fl_PNM_Image(combined1);
		image_box1->image(image1);
		image_box1->redraw();
		
		Object_Camera_Button *red_camera1;
		red_camera1 = new Object_Camera_Button(30,310,250,25,"Red object from Camera 1", 1, 1);
		Object_Camera_Button *green_camera1;
		green_camera1 = new Object_Camera_Button(30,335,250,25,"Green object from Camera 1", 2, 1);
		Object_Camera_Button *blue_camera1;
		blue_camera1 = new Object_Camera_Button(30,360,250,25,"Blue object from Camera 1", 3, 1);
		
		
		
		sprintf(image2,"1000_%s_result.ppm",argv[2]); sprintf(objects2,"objects_1000_%s_result.ppm",argv[2]); sprintf(combined2,"combined_1000_%s_result.ppm",argv[2]);
		image2_matrix = image_to_matrix(image2); objects2_matrix = image_to_matrix(objects2);
		combine_images(image2_matrix, objects2_matrix, combined2, 250, 250);
		
		Fl_Multiline_Output *text2 = new Fl_Multiline_Output(115+30+250,30,80,20);
		camera_text = "Camera 2";
		text2->value(camera_text);
		
		Fl_Box *image_box2 = new Fl_Box(30+250+30,50,250,250);
		Fl_PNM_Image *image2 = new Fl_PNM_Image(combined2);
		image_box2->image(image2);
		image_box2->redraw();
		
		Object_Camera_Button *red_camera2;
		red_camera2 = new Object_Camera_Button(310,310,250,25,"Red object from Camera 2", 1, 2);
		Object_Camera_Button *green_camera2;
		green_camera2 = new Object_Camera_Button(310,335,250,25,"Green object from Camera 2", 2, 2);
		Object_Camera_Button *blue_camera2;
		blue_camera2 = new Object_Camera_Button(310,360,250,25,"Blue object from Camera 2", 3, 2);
		
		
		
		sprintf(image3,"1000_%s_result.ppm",argv[3]); sprintf(objects3,"objects_1000_%s_result.ppm",argv[3]); sprintf(combined3,"combined_1000_%s_result.ppm",argv[3]);
		image3_matrix = image_to_matrix(image3); objects3_matrix = image_to_matrix(objects3);
		combine_images(image3_matrix, objects3_matrix, combined3, 250, 250);
		
		Fl_Multiline_Output *text3 = new Fl_Multiline_Output(115+30+250+30+250,30,80,20);
		camera_text = "Camera 3";
		text3->value(camera_text);
		
		Fl_Box *image_box3 = new Fl_Box(30+250+30+250+30,50,250,250);
		Fl_PNM_Image *image3 = new Fl_PNM_Image(combined3);
		image_box3->image(image3);
		image_box3->redraw();
		
		Object_Camera_Button *red_camera3;
		red_camera3 = new Object_Camera_Button(590,310,250,25,"Red object from Camera 3", 1, 3);
		Object_Camera_Button *green_camera3;
		green_camera3 = new Object_Camera_Button(590,335,250,25,"Green object from Camera 3", 2, 3);
		Object_Camera_Button *blue_camera3;
		blue_camera3 = new Object_Camera_Button(590,360,250,25,"Blue object from Camera 3", 3, 3);
		
	}
	
	
	Fl_Button *done = new Fl_Button(740,625,100,25,"Done"); done->callback(done_cb);
	
	
	
	
	/*Fl_Multiline_Output output(0,0,100,25);


	char *news = "Add this text";
	output.value(news);*/
	
	
	win->end();
	
	win->show();
	
	return(Fl::run());
	
	

}
