#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_PNM_Image.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Wizard.H>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <FL/Fl_Text_Display.H>
#include <iostream>


int convert(int i, int j, int n)
{
int a;
a = (i*n + j);
return a;
}

int convert2(int i, int j, int n, int k)
{
int a;
a = (i*n + j)*3 + k;
return a;
}

int my_mod(int a, int b)
{
	if (a>=0)
		return a%b;
	else
		return (a+b)%b;

}


int *image_to_matrix(char *input_name2)
{
	FILE *input; input = fopen(input_name2,"r");
	
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);

	int n; fscanf(input,"%d",&n);
	int m; fscanf(input,"%d",&m);
	fscanf(input,"%3s",word);



	int *array;
	array = (int*)malloc(m*n*3*sizeof(int));
	int w; int i2; int j2; int k2;
	for (i2=0;i2<m;++i2){
		for (j2=0;j2<n;++j2){
			for (k2=0;k2<3;++k2){
			fscanf(input,"%d",&w);
			array[convert2(i2,j2,n,k2)] = w;
			}
		}
	}
	return array;
}

int image_width(char *input_name2)
{
	FILE *input; input = fopen(input_name2,"r");
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);
	int n; fscanf(input,"%d",&n);
	return n;
}

int image_height(char *input_name2)
{
	FILE *input; input = fopen(input_name2,"r");
	char word[9];
	fscanf(input,"%2s",word);fscanf(input,"%s",word);
	fscanf(input,"%8s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%3s",word);
	fscanf(input,"%6s",word);fscanf(input,"%7s",word);
	fscanf(input,"%3s",word);
	int n; fscanf(input,"%d",&n);
	int m; fscanf(input,"%d",&m);
	return m;
}

int *red_object(int *matrix, int m, int n)
{
	int *answer;
	answer = (int*)malloc(m*n*sizeof(int));
	int i = 0; int j = 0; int aux = 0;
	for (i = 0; i<m; i++){
		for (j = 0; j<n; j++){
			if (matrix[convert2(i,j,n,0)]==255){
				answer[aux] = i; answer[aux+1] = j;
				aux = aux+2; 
			}
			
		}
	}
	return answer;
}

int *green_object(int *matrix, int m, int n)
{
	int *answer;
	answer = (int*)malloc(m*n*sizeof(int));
	int i = 0; int j = 0; int aux = 0;
	for (i = 0; i<m; i++){
		for (j = 0; j<n; j++){
			if (matrix[convert2(i,j,n,1)]==255){
				answer[aux] = i; answer[aux+1] = j;
				aux = aux+2; 
			}
			
		}
	}
	return answer;
}

int *blue_object(int *matrix, int m, int n)
{
	int *answer;
	answer = (int*)malloc(m*n*sizeof(int));
	int i = 0; int j = 0; int aux = 0;
	for (i = 0; i<m; i++){
		for (j = 0; j<n; j++){
			if (matrix[convert2(i,j,n,2)]==255){
				answer[aux] = i; answer[aux+1] = j;
				aux = aux+2; 
			}
			
		}
	}
	return answer;
}

int *get_bounding_box(int *object, int m, int n)
{

	int *bounding_box;
	bounding_box = (int*)malloc(4*sizeof(int));
	int i; int imin = m+1; int imax = -1; int jmin = n+1; int jmax = -1; 
	for (i=0; i<m*n/2; i++)
	{
		if (object[2*i] < imin && object[2*i]!=0)
			imin = object[2*i];
		
		if (object[2*i] > imax && object[2*i]!=0)
			imax = object[2*i];
			
		if (object[2*i+1] < jmin && object[2*i+1]!=0)
			jmin = object[2*i+1];
		
		if (object[2*i+1] > jmax && object[2*i+1]!=0)
			jmax = object[2*i+1];
	
	} 
	bounding_box[0] = imin; bounding_box[1] = imax; bounding_box[2] = jmin; bounding_box[3] = jmax; 
	
	return bounding_box;  

}

int *shift_object(int *object, int shift_i, int shift_j, int m, int n)
{

	int *answer;
	answer = (int*)malloc(m*n*sizeof(int));
	int i = 0; 
	for (i = 0; i<m*n/2; i++){
		if (object[2*i] != 0){
			answer[2*i] = object[2*i] + shift_i; answer[2*i+1] = object[2*i+1] + shift_j;
		}
	}
	return answer;

}

int pixel_object(int *object, int i, int j, int m, int n)
{
	int answer=0;
	int k;
	for (k = 0; k<m*n/2; k++){
		if ((object[2*k] == i) && (object[2*k+1]==j) && (i!=0) && (j!=0))
			answer = 1;
		if ((object[2*k] == 0) && (object[2*k+1]==0) && (object[2*k+2]==0))
			break;
	}
	
	return answer;

}

/*int bounding_box_center_i(int imin, int imax)
{

	int i = (imin + imax)/2;
	return i;

}

int bounding_box_center_j(int jmin, int jmax)
{

	int j = (jmin + jmax)/2;
	return j;

}*/




int main(int argc, char *argv[])
{
	int n = image_width("big_master_camera_objects.ppm");
	//int n = image_width("master_camera_objects.ppm");
	int m = image_height("big_master_camera_objects.ppm");
	//int m = image_height("master_camera_objects.ppm");
	int *master_image = image_to_matrix("big_master_camera_objects.ppm");
	//int *master_image = image_to_matrix("master_camera_objects.ppm");
	int *master_image_no_objects = image_to_matrix("big_master_camera.ppm");
	//int *master_image_no_objects = image_to_matrix("master_camera.ppm");
	
	char *name1; char *name2; char *name3;
	if (argc==2)
		name1 = argv[1];
	
	if (argc==3){
		name1 = argv[1]; name2 = argv[2];}
	
	if (argc==4){
		name1 = argv[1]; name2 = argv[2]; name3 = argv[3];}
		
	FILE *input; 
	int a11, a12, a13, a21, a22, a23, a31, a32, a33;
	input = fopen("objects_from_cameras.txt","r");
	fscanf(input,"%d",&a11); fscanf(input,"%d",&a12); fscanf(input,"%d",&a13);
	fscanf(input,"%d",&a21); fscanf(input,"%d",&a22); fscanf(input,"%d",&a23);
	fscanf(input,"%d",&a31); fscanf(input,"%d",&a32); fscanf(input,"%d",&a33);
	fclose(input);
	
	
	
	
	
	int *master_red = red_object(master_image, m, n);
	int *master_red_bounding_box;  
	master_red_bounding_box = get_bounding_box(master_red, m, n);
	int *red_local_objects;
	int *red_local_image;
	char aux_name[100];
	char aux_name_2[100];
	
	
	
	if (a11 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name1);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name1);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name1);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name1);
		red_local_objects = image_to_matrix(aux_name);
		red_local_image = image_to_matrix(aux_name_2);}
	
	if (a12 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name2);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name2);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name2);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name2);
		red_local_objects = image_to_matrix(aux_name);
		red_local_image = image_to_matrix(aux_name_2);}
		
	if (a13 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name3);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name3);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name3);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name3);
		red_local_objects = image_to_matrix(aux_name);
		red_local_image = image_to_matrix(aux_name_2);}
		
	
	int *local_red = red_object(red_local_objects,m,n);
	int *local_red_bounding_box;
	local_red_bounding_box = get_bounding_box(local_red, m, n);
	
	int shift_red_i = (master_red_bounding_box[1] + master_red_bounding_box[0])/2 - (local_red_bounding_box[1] + local_red_bounding_box[0])/2;
	
	int shift_red_j = (master_red_bounding_box[3] + master_red_bounding_box[2])/2 - (local_red_bounding_box[3] + local_red_bounding_box[2])/2;
	
	int *shifted_red = shift_object(local_red, shift_red_i, shift_red_j, m, n);
	
	
	
	/*printf("\n \n imin=%d, imax=%d, jmin=%d, jmax=%d \n \n", local_red_bounding_box[0], local_red_bounding_box[1], local_red_bounding_box[2], local_red_bounding_box[3]);*/
	
	//printf("\n \n shift_red_i=%d, shift_red_j=%d  \n \n", shift_red_i, shift_red_j);
	
	int *master_green = green_object(master_image, m, n);
	int *master_green_bounding_box;  
	master_green_bounding_box = get_bounding_box(master_green, m, n);
	int *green_local_objects;
	int *green_local_image;
	
	
	if (a21 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name1);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name1);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name1);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name1);
		green_local_objects = image_to_matrix(aux_name);
		green_local_image = image_to_matrix(aux_name_2);}
	
	if (a22 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name2);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name2);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name2);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name2);
		green_local_objects = image_to_matrix(aux_name);
		green_local_image = image_to_matrix(aux_name_2);}
		
	if (a23 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name3);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name3);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name3);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name3);
		green_local_objects = image_to_matrix(aux_name);
		green_local_image = image_to_matrix(aux_name_2);}
		
	
	int *local_green = green_object(green_local_objects,m,n);
	int *local_green_bounding_box;
	local_green_bounding_box = get_bounding_box(local_green, m, n);
	
	int shift_green_i = (master_green_bounding_box[1] + master_green_bounding_box[0])/2 - (local_green_bounding_box[1] + local_green_bounding_box[0])/2;
	
	int shift_green_j = (master_green_bounding_box[3] + master_green_bounding_box[2])/2 - (local_green_bounding_box[3] + local_green_bounding_box[2])/2;
	
	int *shifted_green = shift_object(local_green, shift_green_i, shift_green_j, m, n);
	
	//printf("\n \n shift_green_i=%d, shift_green_j=%d  \n \n", shift_green_i, shift_green_j);
	
	
	
	int *master_blue = blue_object(master_image, m, n);
	int *master_blue_bounding_box;  
	master_blue_bounding_box = get_bounding_box(master_blue, m, n);
	int *blue_local_objects;
	int *blue_local_image;
	
	
	if (a31 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name1);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name1);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name1);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name1);
		blue_local_objects = image_to_matrix(aux_name);
		blue_local_image = image_to_matrix(aux_name_2);}
	
	if (a32 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name2);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name2);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name2);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name2);
		blue_local_objects = image_to_matrix(aux_name);
		blue_local_image = image_to_matrix(aux_name_2);}
		
	if (a33 == 1){
		sprintf(aux_name,"big_objects_1000_%s_result.ppm", name3);
		//sprintf(aux_name,"objects_1000_%s_result.ppm", name3);
		sprintf(aux_name_2,"big_1000_%s_result.ppm", name3);
		//sprintf(aux_name_2,"1000_%s_result.ppm", name3);
		blue_local_objects = image_to_matrix(aux_name);
		blue_local_image = image_to_matrix(aux_name_2);}
		
	
	int *local_blue = blue_object(blue_local_objects,m,n);
	int *local_blue_bounding_box;
	local_blue_bounding_box = get_bounding_box(local_blue, m, n);
	
	int shift_blue_i = (master_blue_bounding_box[1] + master_blue_bounding_box[0])/2 - (local_blue_bounding_box[1] + local_blue_bounding_box[0])/2;
	
	int shift_blue_j = (master_blue_bounding_box[3] + master_blue_bounding_box[2])/2 - (local_blue_bounding_box[3] + local_blue_bounding_box[2])/2;
	
	int *shifted_blue = shift_object(local_blue, shift_blue_i, shift_blue_j, m, n);
	
	//printf("\n \n shift_blue_i=%d, shift_blue_j=%d  \n \n", shift_blue_i, shift_blue_j);	
	
	
	
	

	
	FILE *input2; 
	int b11, b12, b13, b21, b22, b23, b31, b32, b33;
	input2 = fopen("computed_occlusions.txt","r");
	fscanf(input2,"%d",&b11); fscanf(input2,"%d",&b12); fscanf(input2,"%d",&b13);
	fscanf(input2,"%d",&b21); fscanf(input2,"%d",&b22); fscanf(input2,"%d",&b23);
	fscanf(input2,"%d",&b31); fscanf(input2,"%d",&b32); fscanf(input2,"%d",&b33);
	fclose(input2);

	
	int *ima;
	ima = (int*)malloc(m*n*3*sizeof(int)); int i; int j; int k;
	int label_red; int label_green; int label_blue;
	for (i=0;i<m;++i){
		for (j=0;j<n;++j){
		
			label_red = pixel_object(shifted_red, i, j, m, n);
			label_green = pixel_object(shifted_green, i, j, m, n);
			label_blue = pixel_object(shifted_blue, i, j, m, n);
			
			if (label_red == 1 && label_green==1 && label_blue == 1){
				if (b12 == 1 && b13 == 1){
					for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = red_local_image[convert2(i-shift_red_i,j-shift_red_j,n,k)];}
				}
				if (b21 == 1 && b23 == 1){
					for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = green_local_image[convert2(i-shift_green_i,j-shift_green_j,n,k)];}
				}
				if (b31 == 1 && b32 == 1){
					for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = blue_local_image[convert2(i-shift_blue_i,j-shift_blue_j,n,k)];}
				}
				if (b12 == 1 && b23 == 1){
					for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = red_local_image[convert2(i-shift_red_i,j-shift_red_j,n,k)];}
				}
				if (b21 == 1 && b13 == 1){
					for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = green_local_image[convert2(i-shift_green_i,j-shift_green_j,n,k)];}
				}
				if (b31 == 1 && b12 == 1){
					for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = blue_local_image[convert2(i-shift_blue_i,j-shift_blue_j,n,k)];}
				}
					
			}
		
			
			else if (label_red == 1 && label_green==1){
				if (b12 == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = red_local_image[convert2(i-shift_red_i,j-shift_red_j,n,k)];}
				}
				if (b21 == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = green_local_image[convert2(i-shift_green_i,j-shift_green_j,n,k)];}
				}
			}
			
			
			else if (label_red == 1 && label_blue==1){
				if (b13 == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = red_local_image[convert2(i-shift_red_i,j-shift_red_j,n,k)];}
				}
				if (b31 == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = blue_local_image[convert2(i-shift_blue_i,j-shift_blue_j,n,k)];}
				}
			}
			
			
			else if (label_green == 1 && label_blue==1){
				if (b23 == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = green_local_image[convert2(i-shift_green_i,j-shift_green_j,n,k)];}
				}
				if (b32 == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = blue_local_image[convert2(i-shift_blue_i,j-shift_blue_j,n,k)];}
				}
			}
			
						
			else if (label_red == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = red_local_image[convert2(i-shift_red_i,j-shift_red_j,n,k)];}
			}
			
			else if (label_green == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = green_local_image[convert2(i-shift_green_i,j-shift_green_j,n,k)];}
			}
			
			else if (label_blue == 1){
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = blue_local_image[convert2(i-shift_blue_i,j-shift_blue_j,n,k)];}
			}
			
			else {
				if (pixel_object(master_red, i, j, m, n)==1){
					ima[convert2(i,j,n,0)] = 255;
					ima[convert2(i,j,n,1)] = 0;
					ima[convert2(i,j,n,2)] = 0;
				}
				else if (pixel_object(master_green, i, j, m, n)==1){
					ima[convert2(i,j,n,0)] = 0;
					ima[convert2(i,j,n,1)] = 255;
					ima[convert2(i,j,n,2)] = 0;
				}
				else if (pixel_object(master_blue, i, j, m, n)==1){
					ima[convert2(i,j,n,0)] = 0;
					ima[convert2(i,j,n,1)] = 0;
					ima[convert2(i,j,n,2)] = 255;
				}
				else{
				for (k=0;k<3;++k){
					ima[convert2(i,j,n,k)] = master_image_no_objects[convert2(i,j,n,k)];}
				}
			}
		}
	}
	
	
	
	/*AINDA FALTA FAZER OS SUBCASOS, E O ELSE NÃO SERÁ DESSE JEITO, FIZ ASSIM SÓ PRA TER UMA IDEIA DE COMO FICA...*/
	
	
	/*FAZER UMA JANELA NO FINAL QUE ABRA
	
	

/*int z;
for (z=0;z<n2*n2*3;++z)
printf("%d ",ima[z]);*/


/*CREATING A PGM FILE FROM ARRAY IMA*/


	FILE *output;
	output = fopen("final_multiperspecitve_image.ppm","w");
	fprintf(output,"P3\n");
	fprintf(output,"# CREATOR: The GIMP's PNM Filter Version 1.0\n");
	fprintf(output,"%d %d\n", m, n);
	fprintf(output,"255\n");
	int y;
	for (y=0;y<m*n*3;++y)
		fprintf(output,"%d\n", ima[y]);

	fclose(output);
	free(ima);

	
	Fl::scheme("gtk+");
	Fl_Window *win = new Fl_Window(0,0,560,560, "Window 4 - Result");

	Fl_Box *final_image_box = new Fl_Box(30,30,500,500);
	Fl_PNM_Image *image1 = new Fl_PNM_Image("final_multiperspecitve_image.ppm");
	final_image_box->image(image1);
	final_image_box->redraw();


	win->end();
	
	win->show();
	
	return(Fl::run());
	
	
	
}
